%undefine __libtoolize
%define xorg_version 6.8.2-6
%global momorel 2

Summary:   A remote display system.
Name:      vnc
Version:   4.1
Release:   %{momorel}m
URL:       http://www.realvnc.com
Source0:   http://www.realvnc.com/dist/vnc-4_1-unixsrc.tar.gz
Source1:   http://www.realvnc.com/dist/vnc-4.0-javasrc.tar.gz
# This is from 'rpmbuild -bp xorg-x11.spec':
Source2:   xorg-x11-%{xorg_version}.tar.bz2
Source3:   vncserver.init
Source4:   vncconfig.py
Source5:   vnc-16x16.png
Source6:   vnc-24x24.png
Source7:   vnc-48x48.png
Patch0:    vnc-cookie.patch
Patch1:    vnc-gcc4.patch
Patch2:    vnc-use-fb.patch
Patch3:    vnc-xclients.patch
Patch4:    vnc-idle.patch
Patch5:    vnc-via.patch
Patch6:    vnc-module.patch
Patch7:    vnc-fPIC.patch
Patch8:    vnc-restart.patch
Patch10:   vnc-def.patch
Patch11:   vnc-xorg.patch
Patch13:   vnc-xorg-x11-fixes.patch
Patch14:   vnc-render.patch
Patch100:  vnc-4.0-momonga.patch
License:   GPL
Group:     User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: perl tcp_wrappers
BuildRequires: zlib-devel libjpeg-devel xorg-x11-devel
BuildRequires: desktop-file-utils >= 0.2.92
BuildRequires: gcc-java
BuildRequires: patchutils
Prereq:    chkconfig
Requires:  coreutils
Obsoletes: vnc-doc

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%package server
Summary: A VNC server.
Requires: bash >= 2.0
Group: User Interface/X
Prereq: chkconfig

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a VNC server, allowing others
to access the desktop on your machine.

%prep
%setup -q -n vnc-4_1-unixsrc -a1
tar xzvf %SOURCE2 -C unix

%patch0 -p1 -b .cookie
%patch1 -p1 -b .gcc4
%patch2 -p1 -b .use-fb
%patch3 -p1 -b .xclients
%patch4 -p1 -b .idle
%patch5 -p1 -b .via
%patch6 -p1 -b .module
%patch7 -p1 -b .fPIC
%patch8 -p1 -b .restart
%patch10 -p1 -b .def
%patch11 -p1 -b .xorg
%patch13 -p1 -b .xorg-x11-fixes
%patch14 -p1 -b .render

pushd unix
# Apply the patch from the VNC tarball.
filterdiff -x'*/cfbglblt8.c' xc.patch | patch -p0
echo "#include <vnc.def>" > xc/config/cf/host.def
popd

%build
cd unix
autoconf # For use-fb patch
%configure --with-installed-zlib --with-fb
make
mkdir -p java
cd ../vnc-4.0-javasrc
make JAVAC="gcj -C" JAR=gcj-jar

cd ../unix/xc
make CDEBUGFLAGS="%{optflags}" CXXDEBUGFLAGS="%{optflags}" World FAST=1

%install
rm -rf %{buildroot}

cd unix
bin=%{buildroot}%{_bindir}
man=%{buildroot}%{_mandir}
ext=%{buildroot}/usr/X11R6/%{_lib}/modules/extensions
mkdir -p $bin $man $man/man1 $ext
./vncinstall $bin $man $ext
chmod u+w $bin/* $ext/* || :

for i in Xvnc vncpasswd vncserver; do
	mv %{buildroot}%{_bindir}/$i %{buildroot}%{_bindir}/$i.real
done
mv %{buildroot}%{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so \
	%{buildroot}%{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so.real

mkdir -p %{buildroot}%{_datadir}/vnc/classes
cp -aR java/* %{buildroot}%{_datadir}/vnc/classes

mkdir -p %{buildroot}%{_initscriptdir}
install -m755 %{SOURCE3} %{buildroot}%{_initscriptdir}/vncserver

# vncconfig(1) front-end
install -m755 %{SOURCE4} %{buildroot}%{_bindir}/vncconfig.py

mkdir -p %{buildroot}/etc/sysconfig
cat > %{buildroot}/etc/sysconfig/vncservers << EOF
# The VNCSERVERS variable is a list of display:user pairs.
#
# Uncomment the line below to start a VNC server on display :1
# as my 'myusername' (adjust this to your own).  You will also
# need to set a VNC password; run 'man vncpasswd' to see how
# to do that.  
#
# DO NOT RUN THIS SERVICE if your local area network is
# untrusted!  For a secure way of using VNC, see
# <URL:http://www.uk.research.att.com/vnc/sshvnc.html>.

# VNCSERVERS="1:myusername"
# VNCSERVERARGS[1]="-geometry 800x600"
EOF
chmod 644 %{buildroot}/etc/sysconfig/vncservers

mkdir -p %{buildroot}%{_datadir}/icons/hicolor/{16x16,24x24,48x48}/apps
install %{SOURCE5} %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/vnc.png
install %{SOURCE6} %{buildroot}%{_datadir}/icons/hicolor/24x24/apps/vnc.png
install %{SOURCE7} %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/vnc.png
mkdir -p %{buildroot}/etc/X11/applnk/Applications
cat > vncviewer.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=VNC Viewer
Comment=VNC client application
Exec=/usr/bin/vncviewer
Icon=vnc.png
Terminal=false
Type=Application
StartupWMClass=vncviewer
EOF
# Desktop file installation.
mkdir %{buildroot}%{_datadir}/applications
desktop-file-install --vendor vnc --delete-original    \
  --dir %{buildroot}%{_datadir}/applications           \
  --add-category X-Red-Hat-Extra                       \
  --add-category Utility                               \
  --add-category Application                           \
  vncviewer.desktop

%clean
rm -rf %{buildroot}

%post server
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add vncserver
fi
for i in Xvnc vncpasswd vncserver; do
  /usr/sbin/alternatives --install %{_bindir}/$i $i %{_bindir}/$i.real 1
  /usr/sbin/alternatives --set $i %{_bindir}/$i.real
done
/usr/sbin/alternatives --install \
  %{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so \
  vnc.so %{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so.real 1
/usr/sbin/alternatives --set vnc.so \
  %{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so.real


%preun server
if [ "$1" = 0 ]; then
  /sbin/service vncserver stop >/dev/null 2>&1
  /sbin/chkconfig --del vncserver
fi

%postun server
if [ "$1" -ge "1" ]; then
  /sbin/service vncserver condrestart >/dev/null 2>&1
fi
if [ "$1" = 0 ]; then
  for i in Xvnc vncpasswd vncserver; do
    /usr/sbin/alternatives --remove $i %{_bindir}/$i.real
    /usr/sbin/alternatives --auto $i || /bin/true
  done
  /usr/sbin/alternatives --remove vnc.so \
    %{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so.real
  /usr/sbin/alternatives --auto vnc.so || /bin/true
fi

%files
%defattr(-,root,root)
%doc LICENCE.txt README 
%{_bindir}/vncviewer
%{_datadir}/applications/*
%{_mandir}/man1/vncviewer.1*
%{_datadir}/icons/hicolor/*/*/*

%files server
%defattr(-,root,root)
%attr(0755,root,root) %config %{_initscriptdir}/vncserver
%config(noreplace) /etc/sysconfig/vncservers
%{_bindir}/Xvnc.real
%{_bindir}/vncpasswd.real
%{_bindir}/vncconfig
%{_bindir}/vncconfig.py
%{_bindir}/vncserver.real
%{_bindir}/x0vncserver
%{_prefix}/X11R6/%{_lib}/modules/extensions/vnc.so.real
%{_datadir}/vnc
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*

%changelog
* Thu Mar 17 2005 Nakamura Hirotaka <h_nakamura@momonga-linux.org>
- (4.1-2m)
- not use initlog

* Sat Mar 12 2005 Tsutomu Yasuda <tom@tom.homelinux.org>
- (4.1-1m)
  update to 4.1

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (4.0-2m)
- enable x86_64.

* Tue Feb 15 2005 Toru Hoshina <t@momonga-linux.org>
- (4.0-1m)
- version up.

* Thu Jan 13 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.3.3r2-12m)
- import icons from VineSeedPlus
- update desktop file
- change URL

* Sun Jan  8 2005 Toru Hoshina <t@momonga-linux.org>
- (3.3.3r2-11m)
- applied tightvnc-1.2.9-malloc.patch and tightvnc-1.2.9-fdsbits.patch.

* Sat May 22 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (3.3.3r2-10m)
- remove NoSource

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (3.3.3r2-9m)
- revised spec for rpm 4.2.

* Mon Apr 07 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.3.3r2-8m)
- rebuild against zlib 1.1.4-5m

* Wed Aug 21 2002 Masahiro Takahata <takahata@momonga-linux.org>
- update to tight vnc 1.2.2
- include some patch from rawhide

* Tue May  7 2002 Kazuhiko <kazuhiko@kondara.org>
- (3.3.3r2-6k)
- add build-related options in 'make install' :(

* Tue Mar 12 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.3.3r2-4k)
- Use the system-provided zlib instead of the bundled one in Xvnc.

* Sun Sep 22 2001 Toru Hoshina <t@kondara.org>
- (3.3.3r2-2k)
- merge from http://telia.dl.sourceforge.net/vnc-tight

* Fri Aug 17 2001 Const Kaplinsky <const@ce.cctpu.edu.ru>
- TightVNC 1.2.0 updates.

* Tue Jul 24 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-18
- Build requires zlib-devel, libjpeg-devel (bug #49731).

* Fri Jul 13 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-17
- Rebuild to fix file ownership problems.

* Tue Jun  5 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-16
- Really fix bug #28318.
- Use tcp_wrappers (bug #41052).
- Fix build error when using XFree86 4.1.0's imakefile config.

* Fri May  4 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-15
- Add tight encoding patch (includes corre and typo patches).
- Const's Java viewer with tight encoding.
- Update man pages.
- Use the font server (bug #35913).

* Mon Feb 19 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-14
- Make initscript change to user's home directory before starting
  vncserver (bug #28318).
- Make initscript stop properly.

* Thu Feb  8 2001 Tim Waugh <twaugh@redhat.com>
- Change initscript usage string.
- Resync descriptions and summaries to match those from specspo.

* Tue Jan 23 2001 Tim Waugh <twaugh@redhat.com>
- Redo initscript internationalisation.
- Initscript uses bash not sh.

* Fri Jan 19 2001 Tim Waugh <twaugh@redhat.com>
- Xvnc man page: put a pointer to tunnelling through ssh.

* Thu Jan 18 2001 Tim Waugh <twaugh@redhat.com>
- Warn about VNC being insecure in /etc/sysconfig/vncservers.
- CoRRE fix from Const Kaplinsky (bug #24285).

* Mon Jan 15 2001 Tim Waugh <twaugh@redhat.com>
- Initscript internationalisation.

* Tue Dec 12 2000 Tim Waugh <twaugh@redhat.com>
- Service is off by default (bug #22076).
- Don't start VNC server in initscript if user has not set passwd yet
  (bug #22076).

* Thu Dec 07 2000 Tim Waugh <twaugh@redhat.com>
- Mark vncviewer.desktop noreplace.
- Mark vncservers and /etc/rc.d/init.d/vncserver config.
- Add reload to vncserver initscript.
- chkconfig in post.

* Fri Dec 01 2000 Tim Waugh <twaugh@redhat.com>
- Rebuilt because of fileutils bug.

* Mon Nov 06 2000 Tim Waugh <twaugh@redhat.com>
- Include vncpasswd man page in manifest.

* Mon Nov 06 2000 Tim Waugh <twaugh@redhat.com>
- Add vncviewer.desktop.
- Correct typo in vncconnect.c.
- Add man pages.

* Mon Oct 30 2000 Tim Waugh <twaugh@redhat.com>
- set XAUTHORITY before running xstartup.  Fixes vncserver in ssh
  sessions.
- revamp initscript so that it allows for non-root users.

* Thu Oct 26 2000 Tim Waugh <twaugh@redhat.com>
- update to 3.3.3r2.  Patch from bug #19146 no longer needed.
- include new vncconnect program in file list

* Thu Oct 26 2000 Tim Waugh <twaugh@redhat.com>
- fix initscript (bug #19698)

* Tue Oct 17 2000 Than Ngo <than@redhat.com>
- fixed VNC crashes, patch from Shinji Hattori (Bug #10528)

* Mon Oct 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix authentication, Bug #19146, Patch from Tim Waugh <twaugh@redhat.com>

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Remove ,v file from vnc-doc, Bug #12443

* Thu Jul 20 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Preston Brown <pbrown@redhat.com>
- move initscript

* Thu Jun 15 2000 Preston Brown <pbrown@redhat.com>
- move post/postun scripts from main package to server subpackage

* Mon Jun 12 2000 Preston Brown <pbrown@redhat.com>
- preun and postun sections

* Fri Jun 09 2000 Preston Brown <pbrown@redhat.com>
- initial package, from Sean P. Kane package and Mandrake package
- rewrote init script, added condrestart mode
